<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml"
                template="/plantilla-principal.xhtml"
                xmlns:pt="http://xmlns.jcp.org/jsf/passthrough"
                xmlns:jsf="http://xmlns.jcp.org/jsf"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:define name="contenido">
<!--        <f:metadata>
        </f:metadata>-->
        <style>
            #div-btn-elim{
                display: none;
            }
/*            div.scroll{
                height: 600px;
                overflow: auto;
            }*/
        </style>
        <h1>Premio</h1>
        <div class="ui stackable grid">
            <div class="ten wide column">
                <div class="ui secondary menu">
                    <div class="fitted item">
                        <div id="boton-nuevo" class="ui green button">
                            <i class="file icon" />
                            Nuevo
                        </div>
                    </div>
                    <div id="div-btn-elim" class="fitted item">
                        <div class="ui red button">
                            <i class="trash icon"/>
                            Eliminar
                        </div>
                    </div>
                </div>
                <div class="ui fluid icon input search">
                    <input id="txtBuscar" placeholder="Buscar" type="text"></input>
                    <i class="search icon"></i>
                </div>
                <div class="scroll" id="scroll">
                    <h:form id="form-tabla">
                        <table jsf:id="elementos-tabla" class="ui selectable celled table">
                            <thead>
                                <tr>
                                    <th class="collapsing">
                                        <div  class="ui fitted checkbox" onclick="seleccionarTodo()">
                                            <input type="checkbox" id="chk-selec-todo"/>
                                            <label/>
                                        </div>
                                    </th>
                                    <th>ID</th>
                                    <th>Nro Premio</th>
                                    <th>Descripcion</th>                                   
                                </tr>
                            </thead>
                            <tbody>

                                <ui:repeat value="#{premioManBean.premios}" var="premios" varStatus="premiosStatus">
                                    <tr id="pre#{premios.idpremios}">
                                        <td  onclick="seleccionarFila('#{premios.idpremios}')"> 
                                            <div onclick="seleccionarCheck('#{premios.idpremios}')" class="ui fitted checkbox">
                                                <input id="chk-pre-#{premios.idpremios}" type="checkbox" />
                                                <label></label>
                                            </div>
                                        </td>
                                        <td width="25px" id="col-id-premio-#{premios.idpremios}" onclick="seleccionarFila('#{premios.idpremios}')">#{premios.idpremios}</td>
                                        <td id="col-numero-premio-#{premios.idpremios}" onclick="seleccionarFila('#{premios.idpremios}')">#{premios.numeroPremio}</td>
                                        <td id="col-descripcion-premio-#{premios.idpremios}" onclick="seleccionarFila('#{premios.idpremios}')">#{premios.descripcion}</td>
                                    </tr>
                                </ui:repeat>
                            </tbody>
                        </table>
                    </h:form>
                </div>
            </div>
            <div class="six wide column">
                <h:form id="form-datos">
                    <div class="ui divider hidden"></div>
                    <div class="ui divider hidden"></div>
                    <div class="ui form">
                        <div class="field">
                            <label>ID</label>
                            <input disabled="true" jsf:id="idpremio" name="idpremio" jsf:value="#{premioManBean.premioVar.idpremios}" placeholder="ID" type="number" readonly="true"></input>
                            <h:inputHidden id="idpremio-hidden" value="#{premioManBean.premioVar.idpremios}" />
                        </div>
                        <div id="numeropremio" class="required field">
                            <label>Número de Premio</label>
                            <input jsf:id="nropremio" name="nropremio" jsf:value="#{premioManBean.premioVar.numeroPremio}" type="number" placeholder="Nro Premio" required="true" autofocus="true"></input>
                        </div>
                        <div id="descripcionPremio" class="required field">
                            <label>Descripción</label>
                            <input jsf:id="nombrepremio" name="nombrepremio" jsf:value="#{premioManBean.premioVar.descripcion}" placeholder="Descrión Premio" type="text" required="true" autofocus="true"></input>
                        </div>
                        
                        <div class="fields">
                            <div class="thirteen wide field">
                                <div class="required field">
                                    <label>Sorteo</label>
                                    <div id="sorteoPremio" class="ui search selection dropdown">
                                        <input jsf:value="#{premioManBean.idSorteoTmp}" type="hidden"/>
                                        <i class="dropdown icon" />
                                        <div class="default text">Concepto</div>
                                        <div class="menu">
                                            <ui:repeat  value="#{sorteoManBeanPremio.listSorteo}" var="sorteo" varStatus="sorteoStatus">
                                                <div class="item" data-value="#{sorteo.idsorteo}">#{sorteo.descripcion}</div>
                                            </ui:repeat>
                                        </div>
                                    </div> 
                                </div>
                            </div>
                            <div class="four wide field">
                                <label><br/></label>
                                <div id="btn-sorteo" class="ui fluid primary icon button" data-position="left center">
                                    <i class="add circle icon"/>
                                </div>
                            </div>
                        </div>
                        
                    </div>
                    <div id="msg-formulario" class="ui info hidden message">
                        <i class="close icon" />
                        <div class="header">
                            Info
                        </div>
                        <h:outputText id="text-formulario" value="#{premioManBean.msg}"/>
                    </div>
                    <!--</div>-->
                    <p/>
                    <p/>
                    <div class="actions">
                        <!--rendered="#{sessionManBean.permisosAsignados(11)}"-->
                        <h:commandLink id="btn-modif" class="ui teal button" onclick="validarCampos()" action="#{premioManBean.modificarPremio()}">
                            <i class="save icon" />
                            Guardar
                            <f:ajax execute="@form" onevent="function (data) {
                            if (data.status == 'success') {
                            if ($('#msg-formulario').css('display') == 'none') {
                            $('#msg-formulario').transition('fade');
                            }
                            }
                            }" 
                            render="text-formulario form-tabla"/>
                        </h:commandLink>
                       <!--rendered="#{sessionManBean.permisosAsignados(10)}"-->
                        <h:commandLink  id="btn-agre" class="ui primary button" onclick="validarCampos()" action="#{premioManBean.registrarPremio()}">
                            <i class="add circle icon" />
                            Agregar
                            <f:ajax execute="@form" onevent="function (data) {
                            if (data.status == 'success') {
                            if ($('#msg-formulario').css('display') == 'none') {
                            $('#msg-formulario').transition('fade');
                            }
                            }
                            }" 
                            render="text-formulario form-tabla"/>
                        </h:commandLink>
                    </div>
                </h:form>
                
                <div id="popup" class="ui flowing popup center transition hidden">
                    <div class="header">Sorteo:</div>
                    <div class="ui grid">
                        <div class="column">
                            <h:form id="form-sorteo">
                                <div class="disabled field">
                                    <label>Id Sorteo</label>
                                    <input name="id-cargo" placeholder="Id Concepto" jsf:value="#{sorteoManBeanPremio.sorteoVar.idsorteo}" type="text"></input>
                                </div>
                                <div class="field">
                                    <label>Descripión</label>
                                    <input name="nombre-cargo" placeholder="Nombre" jsf:value="#{sorteoManBeanPremio.sorteoVar.descripcion}" type="text"></input>
                                </div>
                                <button  class="ui primary button" jsf:action="#{sorteoManBeanPremio.registrarSorteo()}">
                                    <i class="add circle icon" />
                                    Agregar
                                </button>
                            </h:form>
                        </div>
                    </div>
                </div>
                
                <h:form id="dlg-conf-elim" class="ui basic modal">
                    <input name="selbar" id="selbar" type="hidden" jsf:value="#{premioManBean.seleccionarIdPremioJSON}"/>
            <div class="ui icon header">
                <i class="trash icon"></i>
                Eliminar categoria cliente
            </div>
            <div class="centered content">
                <p>¿Desea eliminar los elementos seleccionados?</p>
            </div>
            <div class="actions">
                <h:commandLink action="#{premioManBean.eliminarPremio()}" class="ui green ok inverted button">
                    <i class="checkmark icon"></i>
                    Sí
                    <f:ajax execute="@form" onevent="generarDatos()" render="form-tabla"/>
                </h:commandLink>

                <div class="ui red basic cancel inverted button">
                    <i class="remove icon"></i>
                    No
                </div>
            </div>
        </h:form>
                
            </div>
        </div>
        <script>
            $('#form-datos #btn-sorteo').popup({
                popup: $('#popup'),
                on: 'click'
                });
            
            $('#form-datos\\:btn-modif').hide();
            $("#boton-nuevo").click(function (){
                $('#form-datos\\:btn-agre').show();
                $('#form-datos\\:btn-modif').hide();
                $('#form-datos\\:nropremio').focus();
                limpiarFormulario();
                removerCampoError();
            });
            
            $('#form-datos\\:btn-agre').click(function (){
                $('#form-datos\\:nropremio').focus();
                limpiarFormulario();
            });
            
            $('#form-datos\\:btn-modif').click(function  (){
                $('#form-datos\\:nroppremio').focus();
                $('#form-datos\\:btn-modif').hide();
                $('#form-datos\\:btn-agre').show();
                $('#div-btn-elim').hide();
                limpiarFormulario();
            });
            
            $('#div-btn-elim').click(function () {
                $('#dlg-conf-elim').modal('show');
            });
            
            $('.message .close').on('click', function () {
                $(this).closest('.message').transition('fade');
            });
            
            function comprobarSeleccionTodo(){
                var seleccionados = $('tbody :checkbox:checked').length;
                var cantfila = $("tbody tr").length;
                if(seleccionados === 0){
                    $("#chk-selec-todo").prop("checked", false);
                }else{
                    if(seleccionados===cantfila){
                        $("#chk-selec-todo").prop("checked", true);
                    }else{
                        $("#chk-selec-todo").prop("checked", false);
                    }
                }
            }
            
            function ocultarBtnEliminarAndModifcar(){
                var seleccionado =$("tbody :checkbox:checked").length;
                if (seleccionado > 0) {
                    $("#div-btn-elim").show();
                    if (seleccionado===1) {
                        $('#form-datos\\:btn-modif').show();
                        $('#form-datos\\:btn-agre').hide();
                    }else{
                       $('#form-datos\\:btn-modif').hide();
                       $('#form-datos\\:btn-agre').show();
                    }
                }else{
                    $("#div-btn-elim").hide();
                    $('#form-datos\\:btn-modif').hide();
                    $('#form-datos\\:btn-agre').show();
                }
            }
            
            function seleccionarFila(idpremio){
                var idfila = '#pre' + idpremio;
                var idchk = '#chk-pre-' + idpremio;
                if($(idfila).hasClass('active')){
                    $(idfila).removeClass('active');
                    $(idchk).prop('checked', false);
                    limpiarFormulario();
                }else {
                    $(idfila).addClass('active');
                    $(idchk).prop('checked', true);
                }
                ocultarBtnEliminarAndModifcar();
                comprobarSeleccionTodo();
                modificar(idpremio);
                removerCampoError();
            }
            
            function seleccionarCheck(idpremio){
                var idchk = '#chk-pre-' + idpremio;
                var idfila = '#pre' + idpremio;
                if($(idchk).prop('checked')){
                    $(idfila).removeClass("active");
                    limpiarFormulario();
                }else {
                    $(idfila).addClass('active');
                    $('#form-datos\\:nropremio').focus();
                }
                ocultarBtnEliminarAndModifcar();
                comprobarSeleccionTodo();
                modificar(idpremio);
                removerCampoError();
            }
            
            function seleccionarTodo(){
                if ($("#chk-selec-todo").prop("checked")) {
                    $("tbody tr").addClass("active");
                    $("tbody :checkbox").prop("checked", true);
                    $('#form-datos\\:btn-modif').hide();
                } else{
                    $("tbody tr").removeClass("active");
                    $("tbody :checkbox").prop("checked", false);
                    limpiarFormulario();
                }
                ocultarBtnEliminarAndModifcar();
            }
            
            function modificar(idpremio){
                $('#form-datos\\:idpremio').val($('#col-id-premio-'+idpremio).html());
                $('#form-datos\\:idpremio-hidden').val($('#col-id-premio-'+idpremio).html());
                $('#form-datos\\:nropremio').val($('#col-numero-premio-'+idpremio).html());
                $('#form-datos\\:nombrepremio').val($('#col-descripcion-premio-'+idpremio).html());
            }
            
            function generarDatos(){
                var idSeleccionados=[];
                $("tbody tr [id^='col-id-premio']").each(function (index, value){
                   var id = parseInt($(this).html());
                   
                   if($('#chk-pre-'+id).prop('checked')){
                       idSeleccionados.push(id);
                   }
                });
                var jsonselect = JSON.stringify(idSeleccionados);
                $('#selbar').val(jsonselect);
                $('#div-btn-elim').hide();
            }
            
            $(document).ready(function(){
                $("#txtBuscar").keyup(function(){
                    if( $(this).val() !== ""){
			$("#form-tabla\\:elementos-tabla tbody>tr").hide();
			$("#form-tabla\\:elementos-tabla td:contains-ci('" + $(this).val() + "')").parent("tr").show();
                    }else{
			$("#form-tabla\\:elementos-tabla tbody>tr").show();
                    }
                });
            });
            $.extend($.expr[":"],{
                "contains-ci": function(elem, i, match, array){
                    return (elem.textContent || elem.innerText || $(elem).text() || "").toLowerCase().indexOf((match[3] || "").toLowerCase()) >= 0;
                }
            });
            
             function limpiarFormulario(){
                $('#form-datos\\:idpremio').val($().html());
                $('#form-datos\\:idpremio-hidden').val($().html());
                $('#form-datos\\:nombrepremio').val($().html());
                $('#form-datos\\:nropremio').val($().html());
                $('#form-datos\\:nropremio').focus();
            }
            
            function validarCampos(){
                var descripcion = $('#form-datos\\:nombrepremio').val();
                var nropremio = $('#form-datos\\:nropremio').val();
                if(descripcion===""){
                    $('#descripionPremio').addClass('error');
                }else {
                    $('#descripionPremio').removeClass('error');
                }
            }
            function removerCampoError(){
                $('#nombreModulo').removeClass('error');
            }
        </script>
    </ui:define>
</ui:composition>